module Triple = struct

    type ('a, 'b, 'c) t = 'a * 'b * 'c

    let fst (a, b, c)  = a
    let snd (a, b, c) = b
    let thd (a, b, c)  = c

end

let make_list length value =
  let rec _make_list acc = function
  | 0 -> acc
  | x -> _make_list (value::acc) (x -1)
  in _make_list [] length

let count_list elem l =
  let rec _count_list acc = function
    | []     -> acc
    | hd::tl -> 
      let count = 
        if hd = elem then
          acc + 1
        else acc
      in _count_list count tl
  in _count_list 0 l

let fold_string (func: 'a -> int -> 'a) init str =
  let max_idx = (String.length str) in
  let rec _fold_str acc idx str =
  if idx = max_idx then acc
  else (
      let ch = String.get str idx
      |> int_of_char
      |> func acc
      in _fold_str ch (idx + 1) str
  )

  in _fold_str init 0 str

